
#define STAP_MSG_RUNTIME_H_01 "myproc-unprivileged tapset function called without is_myproc checking for pid %d (euid %d)"
#define STAP_MSG_LOC2C_01 "read fault [man error::fault] at 0x%p (%s)"
#define STAP_MSG_LOC2C_02 "write fault [man error::fault] at 0x%p (%s)"
#define STAP_MSG_LOC2C_03 "divide by zero in DWARF operand (%s)"
#define STAP_VERSION(a, b) ( ((a) << 8) + (b) )
#ifndef STAP_COMPAT_VERSION
#define STAP_COMPAT_VERSION STAP_VERSION(2, 8)
#endif
#include "runtime_defines.h"
#define _HAVE_PERF_ 1
#include "linux/perf_read.h"
#define STP_PR_STAPUSR 0x2
#define STP_PR_STAPSYS 0x4
#define STP_PR_STAPDEV 0x8
#define STP_PRIVILEGE 0x8
int stp_required_privilege __attribute__ ((section (".stap_privilege"))) = STP_PRIVILEGE;
#ifndef MAXNESTING
#define MAXNESTING 1
#endif
#define STAPREGEX_MAX_STATE0
#define STAPREGEX_MAX_TAG0
#define STP_SKIP_BADVARS 0
#define STP_NEED_UNWIND_DATA 1
#define STP_PROBE_COUNT 1
static void systemtap_module_refresh (const char* modname);
#include <linux/mutex.h>
static DEFINE_MUTEX(module_refresh_mutex);
#include <linux/version.h>
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,17)
#define STP_ON_THE_FLY_TIMER_ENABLE
#endif
#include "runtime.h"

#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/sched.h>
#include <linux/list.h>
#include <linux/blkdev.h>

#include <linux/of.h>
#include <linux/of_address.h>




#include <linux/version.h>
#include <linux/file.h>
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,25)
#include <linux/fdtable.h>
#endif
#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,9,0)
#include <linux/sched/rt.h>
#endif
#ifndef STAPCONF_TASK_UID
#include <linux/cred.h>
#endif



#define __STP_GET_USER(t, warn)						\
	do {								\
		__label__ deref_fault;					\
		t *_ptr = (t*) (intptr_t) STAP_ARG_addr;		\
		STAP_RETVALUE = uread (_ptr);				\
		if (0) {						\
		deref_fault:						\
			STAP_RETVALUE = 0;				\
			CONTEXT->last_error = NULL;			\
			if (warn) {					\
				snprintf(CONTEXT->error_buffer,		\
				    sizeof(CONTEXT->error_buffer),	\
				    "user %s copy fault %p [man error::fault]", #t, _ptr);	\
				_stp_warn(CONTEXT->error_buffer);	\
			}						\
		}							\
	} while (0)

#define STP_GET_USER(t) __STP_GET_USER(t, 0)
#define STP_GET_USER_WARN(t) __STP_GET_USER(t, 1)



#define STAP_NEED_CONTEXT_TOKENIZE 1



#include <linux/version.h>



struct context {
  #include "common_probe_context.h"
  union {
    struct probe_2653_locals {
      int64_t l_get_clk;
      int64_t l_pid;
      int64_t l_tid;
      int64_t l_uaddr;
      string_t l_sample;
      int64_t l_remaining;
      int64_t l_depth;
      int64_t l_addr;
      string_t l_name;
      int64_t l_base;
      string_t l_file;
      union { /* block_statement: /opt/tooling/adit/systemtap/share/systemtap/tapset/linux/perf.stp:20 */
        struct { /* source: taptrek_run_ZIX2.stp:31 */
          int64_t __tmp2;
        };
        struct { /* source: taptrek_run_ZIX2.stp:32 */
          int64_t __tmp5;
        };
        struct { /* source: taptrek_run_ZIX2.stp:33 */
          int64_t __tmp8;
        };
        struct { /* source: taptrek_run_ZIX2.stp:34 */
          string_t __tmp11;
          int64_t __tmp13;
          int64_t __tmp14;
          int64_t __tmp15;
          string_t __tmp16;
        };
        struct { /* source: taptrek_run_ZIX2.stp:35 */
          int64_t __tmp17;
        };
        struct { /* source: taptrek_run_ZIX2.stp:37 */
          union { /* if_statement: taptrek_run_ZIX2.stp:37 */
            struct { /* source: taptrek_run_ZIX2.stp:38 */
              union { /* block_statement: taptrek_run_ZIX2.stp:38 */
                struct { /* source: taptrek_run_ZIX2.stp:39 */
                  union { /* for_loop: taptrek_run_ZIX2.stp:39 */
                    struct { /* source: taptrek_run_ZIX2.stp:40 */
                      union { /* block_statement: taptrek_run_ZIX2.stp:40 */
                        struct { /* source: taptrek_run_ZIX2.stp:41 */
                          int64_t __tmp22;
                          int64_t __tmp24;
                        };
                        struct { /* source: taptrek_run_ZIX2.stp:42 */
                          union { /* if_statement: taptrek_run_ZIX2.stp:42 */
                          };
                        };
                        struct { /* source: taptrek_run_ZIX2.stp:43 */
                          union { /* try_block: taptrek_run_ZIX2.stp:43 */
                            struct { /* source: taptrek_run_ZIX2.stp:43 */
                              string_t __tmp26;
                              int64_t __tmp28;
                              string_t __tmp29;
                            };
                          };
                        };
                        struct { /* source: taptrek_run_ZIX2.stp:44 */
                          string_t __tmp32;
                          int64_t __tmp34;
                          string_t __tmp35;
                          string_t __tmp36;
                        };
                      };
                    };
                    struct { /* source: taptrek_run_ZIX2.stp:39 */
                      int64_t __tmp38;
                    };
                  };
                };
                struct { /* source: taptrek_run_ZIX2.stp:46 */
                  int64_t __tmp39;
                };
              };
            };
          };
        };
        struct { /* source: taptrek_run_ZIX2.stp:48 */
          union { /* if_statement: taptrek_run_ZIX2.stp:48 */
            struct { /* source: taptrek_run_ZIX2.stp:50 */
              union { /* for_loop: taptrek_run_ZIX2.stp:50 */
                struct { /* source: taptrek_run_ZIX2.stp:51 */
                  union { /* block_statement: taptrek_run_ZIX2.stp:51 */
                    struct { /* source: taptrek_run_ZIX2.stp:52 */
                      int64_t __tmp43;
                      int64_t __tmp45;
                    };
                    struct { /* source: taptrek_run_ZIX2.stp:53 */
                      union { /* if_statement: taptrek_run_ZIX2.stp:53 */
                      };
                    };
                    struct { /* source: taptrek_run_ZIX2.stp:54 */
                      int64_t __tmp47;
                      int64_t __tmp49;
                    };
                    struct { /* source: taptrek_run_ZIX2.stp:55 */
                      union { /* if_statement: taptrek_run_ZIX2.stp:55 */
                        struct { /* source: taptrek_run_ZIX2.stp:56 */
                          union { /* block_statement: taptrek_run_ZIX2.stp:56 */
                            struct { /* source: taptrek_run_ZIX2.stp:58 */
                              string_t __tmp51;
                              int64_t __tmp53;
                              string_t __tmp54;
                            };
                            struct { /* source: taptrek_run_ZIX2.stp:59 */
                              string_t __tmp55;
                              int64_t __tmp57;
                              string_t __tmp58;
                              string_t __tmp59;
                            };
                          };
                        };
                      };
                    };
                  };
                };
                struct { /* source: taptrek_run_ZIX2.stp:50 */
                  int64_t __tmp61;
                };
              };
            };
          };
        };
        struct { /* source: taptrek_run_ZIX2.stp:63 */
          string_t __tmp62;
        };
      };
    } probe_2653;
  } probe_locals;
  union {
    struct function___stack_raw_locals {
      int64_t l_n;
      int64_t __retvalue;
    } function___stack_raw;
    struct function___ustack_raw_locals {
      int64_t l_n;
      int64_t __retvalue;
    } function___ustack_raw;
    struct function_find_base_locals {
      int64_t l_addr;
      int64_t __retvalue;
    } function_find_base;
    struct function_find_file_locals {
      int64_t l_addr;
      char * __retvalue;
    } function_find_file;
    struct function_modname_locals {
      int64_t l_addr;
      char * __retvalue;
    } function_modname;
    struct function_pid_locals {
      int64_t __retvalue;
    } function_pid;
    struct function_tid_locals {
      int64_t __retvalue;
    } function_tid;
    struct function_uaddr_locals {
      int64_t __retvalue;
    } function_uaddr;
    struct function_user_mode_locals {
      int64_t __retvalue;
    } function_user_mode;
  } locals [MAXNESTING+1];
  #if MAXNESTING < 0
  #error "MAXNESTING must be positive"
  #endif
  #ifndef STP_LEGACY_PRINT
  union {
    struct stp_sprintf_2_locals {
      int64_t arg0;
      const char* arg1;
      char * __retvalue;
    } stp_sprintf_2;
    struct stp_sprintf_1_locals {
      int64_t arg0;
      int64_t arg1;
      int64_t arg2;
      char * __retvalue;
    } stp_sprintf_1;
    struct stp_printf_3_locals {
      const char* arg0;
    } stp_printf_3;
  } printf_locals;
  #endif // STP_LEGACY_PRINT
};

#include "runtime_context.h"
#ifndef STP_LEGACY_PRINT

static void stp_sprintf_2 (struct context* __restrict__ c) {
  struct stp_sprintf_2_locals * __restrict__ l = & c->printf_locals.stp_sprintf_2;
  char *str = NULL, *end = NULL;
  const char *src;
  int width;
  int precision;
  unsigned long ptr_value;
  int num_bytes;
  (void) width;
  (void) precision;
  (void) ptr_value;
  (void) num_bytes;
  str = l->__retvalue;
  end = str + MAXSTRINGLEN - 1;
  if (str && str <= end) {
    src = ":";
    while (*src && str <= end)
      *str++ = *src++;
    width = -1;
    precision = -1;
    str = number(str, end, l->arg0, 16, width, precision, 32);
    src = ":";
    while (*src && str <= end)
      *str++ = *src++;
    width = -1;
    precision = -1;
    str = _stp_vsprint_memory(str, end, l->arg1, width, precision, 's', 0);
    if (str <= end)
      *str = '\0';
    else
      *end = '\0';
  }
}

static void stp_sprintf_1 (struct context* __restrict__ c) {
  struct stp_sprintf_1_locals * __restrict__ l = & c->printf_locals.stp_sprintf_1;
  char *str = NULL, *end = NULL;
  const char *src;
  int width;
  int precision;
  unsigned long ptr_value;
  int num_bytes;
  (void) width;
  (void) precision;
  (void) ptr_value;
  (void) num_bytes;
  str = l->__retvalue;
  end = str + MAXSTRINGLEN - 1;
  if (str && str <= end) {
    src = "[";
    while (*src && str <= end)
      *str++ = *src++;
    width = -1;
    precision = -1;
    str = number(str, end, l->arg0, 10, width, precision, 0);
    src = "ns]p:";
    while (*src && str <= end)
      *str++ = *src++;
    width = -1;
    precision = -1;
    str = number(str, end, l->arg1, 10, width, precision, 2);
    src = ":";
    while (*src && str <= end)
      *str++ = *src++;
    width = -1;
    precision = -1;
    str = number(str, end, l->arg2, 10, width, precision, 2);
    if (str <= end)
      *str = '\0';
    else
      *end = '\0';
  }
}

static void stp_printf_3 (struct context* __restrict__ c) {
  struct stp_printf_3_locals * __restrict__ l = & c->printf_locals.stp_printf_3;
  char *str = NULL, *end = NULL;
  const char *src;
  int width;
  int precision;
  unsigned long ptr_value;
  int num_bytes;
  (void) width;
  (void) precision;
  (void) ptr_value;
  (void) num_bytes;
  num_bytes = 0;
  width = -1;
  precision = -1;
  num_bytes += _stp_vsprint_memory_size(l->arg0, width, precision, 's', 0);
  num_bytes += sizeof("\n") - 1;
  num_bytes = clamp(num_bytes, 0, STP_BUFFER_SIZE);
  str = (char*)_stp_reserve_bytes(num_bytes);
  end = str ? str + num_bytes - 1 : 0;
  if (str && str <= end) {
    width = -1;
    precision = -1;
    str = _stp_vsprint_memory(str, end, l->arg0, width, precision, 's', 0);
    src = "\n";
    while (*src && str <= end)
      *str++ = *src++;
  }
}
#endif // STP_LEGACY_PRINT
static atomic_t need_module_refresh = ATOMIC_INIT(0);
#include <linux/workqueue.h>
static struct work_struct module_refresher_work;
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)
static void module_refresher(void *data) {
#else
static void module_refresher(struct work_struct *work) {
#endif
  systemtap_module_refresh(NULL);
}
#ifdef STP_ON_THE_FLY_TIMER_ENABLE
#include <linux/hrtimer.h>
#include "timer.h"
static struct hrtimer module_refresh_timer;
#ifndef STP_ON_THE_FLY_INTERVAL
#define STP_ON_THE_FLY_INTERVAL (100*1000*1000)
#endif
hrtimer_return_t module_refresh_timer_cb(struct hrtimer *timer) {
  if (atomic_cmpxchg(&need_module_refresh, 1, 0) == 1)
    schedule_work(&module_refresher_work);
  hrtimer_set_expires(timer,
    ktime_add(hrtimer_get_expires(timer),
              ktime_set(0, STP_ON_THE_FLY_INTERVAL))); 
  return HRTIMER_RESTART;
}
#endif /* STP_ON_THE_FLY_TIMER_ENABLE */

#include "stack.c"
struct stp_globals {};

#include "common_session_state.h"
#include "probe_lock.h" 
#ifdef STAP_NEED_GETTIMEOFDAY
#include "time.c"
#endif

static void function___stack_raw (struct context * __restrict__ c);

static void function___ustack_raw (struct context * __restrict__ c);

static void function_find_base (struct context * __restrict__ c);

static void function_find_file (struct context * __restrict__ c);

static void function_modname (struct context * __restrict__ c);

static void function_pid (struct context * __restrict__ c);

static void function_tid (struct context * __restrict__ c);

static void function_uaddr (struct context * __restrict__ c);

static void function_user_mode (struct context * __restrict__ c);

static void function___stack_raw (struct context* __restrict__ c) {
  __label__ out;
  struct function___stack_raw_locals *  __restrict__ l = & c->locals[c->nesting+1].function___stack_raw;
  (void) l;
  #define CONTEXT c
  #define THIS l
  #define STAP_ARG_n THIS->l_n
  #define STAP_RETVALUE THIS->__retvalue
  c->last_stmt = "identifier '__stack_raw' at /opt/tooling/adit/systemtap/share/systemtap/tapset/linux/context-symbols.stp:15:10";
  if (unlikely (c->nesting+1 >= MAXNESTING)) {
    c->last_error = "MAXNESTING exceeded";
    return;
  } else {
    c->nesting ++;
  }
  l->__retvalue = 0;
  #define STAP_RETURN(v) do { STAP_RETVALUE = (int64_t) (v); goto out; } while(0)
  #define STAP_ERROR(...) do { snprintf(CONTEXT->error_buffer, MAXSTRINGLEN, __VA_ARGS__); CONTEXT->last_error = CONTEXT->error_buffer; goto out; } while (0)
  #define return goto out
  if (c->actionremaining < 0) { c->last_error = "MAXACTION exceeded";goto out; }
  {
     /* pragma:unwind */ /* pure */
         /* basic sanity check for bounds: */
         if (unlikely(STAP_ARG_n < 0 || STAP_ARG_n >= MAXBACKTRACE))
                  STAP_RETVALUE = 0;
         else
                  STAP_RETVALUE = _stp_stack_kernel_get (CONTEXT, (unsigned)STAP_ARG_n);

  }
  #undef return
  #undef STAP_ERROR
  #undef STAP_RETURN
out:
  if (0) goto out;
  c->nesting --;
  #undef CONTEXT
  #undef THIS
  #undef STAP_ARG_n
  #undef STAP_RETVALUE
}


static void function___ustack_raw (struct context* __restrict__ c) {
  __label__ out;
  struct function___ustack_raw_locals *  __restrict__ l = & c->locals[c->nesting+1].function___ustack_raw;
  (void) l;
  #define CONTEXT c
  #define THIS l
  #define STAP_ARG_n THIS->l_n
  #define STAP_RETVALUE THIS->__retvalue
  c->last_stmt = "identifier '__ustack_raw' at /opt/tooling/adit/systemtap/share/systemtap/tapset/linux/ucontext-symbols.stp:16:10";
  if (unlikely (c->nesting+1 >= MAXNESTING)) {
    c->last_error = "MAXNESTING exceeded";
    return;
  } else {
    c->nesting ++;
  }
  l->__retvalue = 0;
  #define STAP_RETURN(v) do { STAP_RETVALUE = (int64_t) (v); goto out; } while(0)
  #define STAP_ERROR(...) do { snprintf(CONTEXT->error_buffer, MAXSTRINGLEN, __VA_ARGS__); CONTEXT->last_error = CONTEXT->error_buffer; goto out; } while (0)
  #define return goto out
  if (c->actionremaining < 0) { c->last_error = "MAXACTION exceeded";goto out; }
  assert_is_myproc();
  {
     /* pragma:unwind */ /* pure */ /* myproc-unprivileged */
         /* basic sanity check for bounds: */
         if (unlikely(STAP_ARG_n < 0 || STAP_ARG_n >= MAXBACKTRACE))
                  STAP_RETVALUE = 0;
         else
                  STAP_RETVALUE = _stp_stack_user_get (CONTEXT, (unsigned)STAP_ARG_n);

  }
  #undef return
  #undef STAP_ERROR
  #undef STAP_RETURN
out:
  if (0) goto out;
  c->nesting --;
  #undef CONTEXT
  #undef THIS
  #undef STAP_ARG_n
  #undef STAP_RETVALUE
}


static void function_find_base (struct context* __restrict__ c) {
  __label__ out;
  struct function_find_base_locals *  __restrict__ l = & c->locals[c->nesting+1].function_find_base;
  (void) l;
  #define CONTEXT c
  #define THIS l
  #define STAP_ARG_addr THIS->l_addr
  #define STAP_RETVALUE THIS->__retvalue
  c->last_stmt = "identifier 'find_base' at taptrek_run_ZIX2.stp:18:10";
  if (unlikely (c->nesting+1 >= MAXNESTING)) {
    c->last_error = "MAXNESTING exceeded";
    return;
  } else {
    c->nesting ++;
  }
  l->__retvalue = 0;
  #define STAP_RETURN(v) do { STAP_RETVALUE = (int64_t) (v); goto out; } while(0)
  #define STAP_ERROR(...) do { snprintf(CONTEXT->error_buffer, MAXSTRINGLEN, __VA_ARGS__); CONTEXT->last_error = CONTEXT->error_buffer; goto out; } while (0)
  #define return goto out
  if (c->actionremaining < 0) { c->last_error = "MAXACTION exceeded";goto out; }
  {
     /* pure */ /* unprivileged */
   STAP_RETVALUE = STAP_ARG_addr;

  }
  #undef return
  #undef STAP_ERROR
  #undef STAP_RETURN
out:
  if (0) goto out;
  c->nesting --;
  #undef CONTEXT
  #undef THIS
  #undef STAP_ARG_addr
  #undef STAP_RETVALUE
}


static void function_find_file (struct context* __restrict__ c) {
  __label__ out;
  struct function_find_file_locals *  __restrict__ l = & c->locals[c->nesting+1].function_find_file;
  (void) l;
  #define CONTEXT c
  #define THIS l
  #define STAP_ARG_addr THIS->l_addr
  #define STAP_RETVALUE THIS->__retvalue
  c->last_stmt = "identifier 'find_file' at taptrek_run_ZIX2.stp:23:10";
  if (unlikely (c->nesting+1 >= MAXNESTING)) {
    c->last_error = "MAXNESTING exceeded";
    return;
  } else {
    c->nesting ++;
  }
  l->__retvalue[0] = '\0';
  #define STAP_RETURN(v) do { strlcpy(STAP_RETVALUE, (v), MAXSTRINGLEN); goto out; } while(0)
  #define STAP_ERROR(...) do { snprintf(CONTEXT->error_buffer, MAXSTRINGLEN, __VA_ARGS__); CONTEXT->last_error = CONTEXT->error_buffer; goto out; } while (0)
  #define return goto out
  if (c->actionremaining < 0) { c->last_error = "MAXACTION exceeded";goto out; }
  {
     /* pure */ /* unprivileged */
	STAP_RETVALUE[0] = '\0';

  }
  #undef return
  #undef STAP_ERROR
  #undef STAP_RETURN
out:
  if (0) goto out;
  c->nesting --;
  #undef CONTEXT
  #undef THIS
  #undef STAP_ARG_addr
  #undef STAP_RETVALUE
}


static void function_modname (struct context* __restrict__ c) {
  __label__ out;
  struct function_modname_locals *  __restrict__ l = & c->locals[c->nesting+1].function_modname;
  (void) l;
  #define CONTEXT c
  #define THIS l
  #define STAP_ARG_addr THIS->l_addr
  #define STAP_RETVALUE THIS->__retvalue
  c->last_stmt = "identifier 'modname' at /opt/tooling/adit/systemtap/share/systemtap/tapset/linux/context-symbols.stp:189:10";
  if (unlikely (c->nesting+1 >= MAXNESTING)) {
    c->last_error = "MAXNESTING exceeded";
    return;
  } else {
    c->nesting ++;
  }
  l->__retvalue[0] = '\0';
  #define STAP_RETURN(v) do { strlcpy(STAP_RETVALUE, (v), MAXSTRINGLEN); goto out; } while(0)
  #define STAP_ERROR(...) do { snprintf(CONTEXT->error_buffer, MAXSTRINGLEN, __VA_ARGS__); CONTEXT->last_error = CONTEXT->error_buffer; goto out; } while (0)
  #define return goto out
  if (c->actionremaining < 0) { c->last_error = "MAXACTION exceeded";goto out; }
  {
     /* pure */
	struct _stp_module *m;
#ifdef STAPCONF_MODULE_TEXT_ADDRESS
	struct module *ko;
#endif
	m = _stp_kmod_sec_lookup (STAP_ARG_addr, NULL);
	if (m && m->name)
	  {
	    strlcpy (STAP_RETVALUE, m->name, MAXSTRINGLEN);
	    return;
	  }

#ifdef STAPCONF_MODULE_TEXT_ADDRESS
	preempt_disable();
	ko = __module_text_address (STAP_ARG_addr);
	if (ko && ko->name)
	  {
	    strlcpy (STAP_RETVALUE, ko->name, MAXSTRINGLEN);
	    preempt_enable_no_resched();
	    return;
	  }
	preempt_enable_no_resched();
#endif
#if STAP_COMPAT_VERSION <= STAP_VERSION(2,2)
	strlcpy (STAP_RETVALUE, "<unknown>", MAXSTRINGLEN);
#else
	CONTEXT->last_error = "Cannot determine kernel module name";
#endif

  }
  #undef return
  #undef STAP_ERROR
  #undef STAP_RETURN
out:
  if (0) goto out;
  c->nesting --;
  #undef CONTEXT
  #undef THIS
  #undef STAP_ARG_addr
  #undef STAP_RETVALUE
}


static void function_pid (struct context* __restrict__ c) {
  __label__ out;
  struct function_pid_locals *  __restrict__ l = & c->locals[c->nesting+1].function_pid;
  (void) l;
  #define CONTEXT c
  #define THIS l
  #define STAP_RETVALUE THIS->__retvalue
  c->last_stmt = "identifier 'pid' at /opt/tooling/adit/systemtap/share/systemtap/tapset/linux/context.stp:27:10";
  if (unlikely (c->nesting+1 >= MAXNESTING)) {
    c->last_error = "MAXNESTING exceeded";
    return;
  } else {
    c->nesting ++;
  }
  l->__retvalue = 0;
  #define STAP_RETURN(v) do { STAP_RETVALUE = (int64_t) (v); goto out; } while(0)
  #define STAP_ERROR(...) do { snprintf(CONTEXT->error_buffer, MAXSTRINGLEN, __VA_ARGS__); CONTEXT->last_error = CONTEXT->error_buffer; goto out; } while (0)
  #define return goto out
  if (c->actionremaining < 0) { c->last_error = "MAXACTION exceeded";goto out; }
  {
     /* pure */ /* unprivileged */
	STAP_RETVALUE = current->tgid;

  }
  #undef return
  #undef STAP_ERROR
  #undef STAP_RETURN
out:
  if (0) goto out;
  c->nesting --;
  #undef CONTEXT
  #undef THIS
  #undef STAP_RETVALUE
}


static void function_tid (struct context* __restrict__ c) {
  __label__ out;
  struct function_tid_locals *  __restrict__ l = & c->locals[c->nesting+1].function_tid;
  (void) l;
  #define CONTEXT c
  #define THIS l
  #define STAP_RETVALUE THIS->__retvalue
  c->last_stmt = "identifier 'tid' at /opt/tooling/adit/systemtap/share/systemtap/tapset/linux/context.stp:37:10";
  if (unlikely (c->nesting+1 >= MAXNESTING)) {
    c->last_error = "MAXNESTING exceeded";
    return;
  } else {
    c->nesting ++;
  }
  l->__retvalue = 0;
  #define STAP_RETURN(v) do { STAP_RETVALUE = (int64_t) (v); goto out; } while(0)
  #define STAP_ERROR(...) do { snprintf(CONTEXT->error_buffer, MAXSTRINGLEN, __VA_ARGS__); CONTEXT->last_error = CONTEXT->error_buffer; goto out; } while (0)
  #define return goto out
  if (c->actionremaining < 0) { c->last_error = "MAXACTION exceeded";goto out; }
  {
     /* pure */ /* unprivileged */
	STAP_RETVALUE = current->pid;

  }
  #undef return
  #undef STAP_ERROR
  #undef STAP_RETURN
out:
  if (0) goto out;
  c->nesting --;
  #undef CONTEXT
  #undef THIS
  #undef STAP_RETVALUE
}


static void function_uaddr (struct context* __restrict__ c) {
  __label__ out;
  struct function_uaddr_locals *  __restrict__ l = & c->locals[c->nesting+1].function_uaddr;
  (void) l;
  #define CONTEXT c
  #define THIS l
  #define STAP_RETVALUE THIS->__retvalue
  c->last_stmt = "identifier 'uaddr' at /opt/tooling/adit/systemtap/share/systemtap/tapset/linux/context.stp:389:10";
  if (unlikely (c->nesting+1 >= MAXNESTING)) {
    c->last_error = "MAXNESTING exceeded";
    return;
  } else {
    c->nesting ++;
  }
  l->__retvalue = 0;
  #define STAP_RETURN(v) do { STAP_RETVALUE = (int64_t) (v); goto out; } while(0)
  #define STAP_ERROR(...) do { snprintf(CONTEXT->error_buffer, MAXSTRINGLEN, __VA_ARGS__); CONTEXT->last_error = CONTEXT->error_buffer; goto out; } while (0)
  #define return goto out
  if (c->actionremaining < 0) { c->last_error = "MAXACTION exceeded";goto out; }
  assert_is_myproc();
  {
     /* pure */ /* myproc-unprivileged */
  struct pt_regs *uregs;

  if (CONTEXT->user_mode_p)
    uregs = CONTEXT->uregs;
  else
    uregs = _stp_current_pt_regs();

  if (uregs)
    STAP_RETVALUE = (int64_t) REG_IP(uregs);
  else
    STAP_RETVALUE = 0;

  }
  #undef return
  #undef STAP_ERROR
  #undef STAP_RETURN
out:
  if (0) goto out;
  c->nesting --;
  #undef CONTEXT
  #undef THIS
  #undef STAP_RETVALUE
}


static void function_user_mode (struct context* __restrict__ c) {
  __label__ out;
  struct function_user_mode_locals *  __restrict__ l = & c->locals[c->nesting+1].function_user_mode;
  (void) l;
  #define CONTEXT c
  #define THIS l
  #define STAP_RETVALUE THIS->__retvalue
  c->last_stmt = "identifier 'user_mode' at /opt/tooling/adit/systemtap/share/systemtap/tapset/linux/context.stp:234:10";
  if (unlikely (c->nesting+1 >= MAXNESTING)) {
    c->last_error = "MAXNESTING exceeded";
    return;
  } else {
    c->nesting ++;
  }
  l->__retvalue = 0;
  #define STAP_RETURN(v) do { STAP_RETVALUE = (int64_t) (v); goto out; } while(0)
  #define STAP_ERROR(...) do { snprintf(CONTEXT->error_buffer, MAXSTRINGLEN, __VA_ARGS__); CONTEXT->last_error = CONTEXT->error_buffer; goto out; } while (0)
  #define return goto out
  if (c->actionremaining < 0) { c->last_error = "MAXACTION exceeded";goto out; }
  {
     /* pure */ /* unprivileged */
  STAP_RETVALUE = CONTEXT->user_mode_p ? 1 : 0;

  }
  #undef return
  #undef STAP_ERROR
  #undef STAP_RETURN
out:
  if (0) goto out;
  c->nesting --;
  #undef CONTEXT
  #undef THIS
  #undef STAP_RETVALUE
}


struct stap_probe {
  const size_t index;
  void (* const ph) (struct context*);
  unsigned cond_enabled:1;
  #if defined(STP_TIMING) || defined(STP_ALIBI)
  const char location[28];
  const char derivation[128];
  #define STAP_PROBE_INIT_TIMING(L, D) .location=(L), .derivation=(D),
  #else
  #define STAP_PROBE_INIT_TIMING(L, D)
  #endif
  const char pp[41];
  #ifdef STP_NEED_PROBE_NAME
  const char pn[36];
  #define STAP_PROBE_INIT_NAME(PN) .pn=(PN),
  #else
  #define STAP_PROBE_INIT_NAME(PN)
  #endif
  #define STAP_PROBE_INIT(I, PH, PP, PN, L, D) { .index=(I), .ph=(PH), .cond_enabled=1, .pp=(PP), STAP_PROBE_INIT_NAME(PN) STAP_PROBE_INIT_TIMING(L, D) }
} static stap_probes[];

static void probe_2653 (struct context * __restrict__ c) {
  __label__ out;
  static const struct stp_probe_lock locks[] = {
  };
  struct probe_2653_locals * __restrict__ l = & c->probe_locals.probe_2653;
  (void) l;
  #if ! STP_PRIVILEGE_CONTAINS (STP_PRIVILEGE, STP_PR_STAPDEV) && \
      ! STP_PRIVILEGE_CONTAINS (STP_PRIVILEGE, STP_PR_STAPSYS)
  #error Internal Error: Probe perf.type(1).config(0).sample(1000000) generated in --unprivileged mode
  #endif
  if (!stp_lock_probe(locks, ARRAY_SIZE(locks)))
    return;
  l->l_get_clk = 0;
  l->l_pid = 0;
  l->l_tid = 0;
  l->l_uaddr = 0;
  l->l_sample[0] = '\0';
  l->l_remaining = 0;
  l->l_depth = 0;
  l->l_addr = 0;
  l->l_name[0] = '\0';
  l->l_base = 0;
  l->l_file[0] = '\0';
  {
    (void) 
    ({
      l->l_get_clk = ((int64_t)0LL);
      ((int64_t)0LL);
    });
    
    (void) 
    ({
      l->__tmp2 = 
      ({
        function_pid (c);
        if (unlikely(c->last_error)) goto out;
        c->actionremaining -= 1;
        if (unlikely (c->actionremaining <= 0)) {
          c->last_error = "MAXACTION exceeded";
          c->last_stmt = "identifier 'pid' at taptrek_run_ZIX2.stp:31:21";
          goto out;
        }
        c->locals[c->nesting+1].function_pid.__retvalue;
      });
      l->l_pid = l->__tmp2;
      l->__tmp2;
    });
    
    (void) 
    ({
      l->__tmp5 = 
      ({
        function_tid (c);
        if (unlikely(c->last_error)) goto out;
        c->actionremaining -= 1;
        if (unlikely (c->actionremaining <= 0)) {
          c->last_error = "MAXACTION exceeded";
          c->last_stmt = "identifier 'tid' at taptrek_run_ZIX2.stp:32:21";
          goto out;
        }
        c->locals[c->nesting+1].function_tid.__retvalue;
      });
      l->l_tid = l->__tmp5;
      l->__tmp5;
    });
    
    (void) 
    ({
      l->__tmp8 = 
      ({
        function_uaddr (c);
        if (unlikely(c->last_error)) goto out;
        c->actionremaining -= 1;
        if (unlikely (c->actionremaining <= 0)) {
          c->last_error = "MAXACTION exceeded";
          c->last_stmt = "identifier 'uaddr' at taptrek_run_ZIX2.stp:33:21";
          goto out;
        }
        c->locals[c->nesting+1].function_uaddr.__retvalue;
      });
      l->l_uaddr = l->__tmp8;
      l->__tmp8;
    });
    
    (void) 
    ({
      strlcpy (l->__tmp11, 
      ({
        l->__tmp13 = l->l_get_clk;
        l->__tmp14 = l->l_pid;
        l->__tmp15 = l->l_tid;
        #ifndef STP_LEGACY_PRINT
          c->printf_locals.stp_sprintf_1.arg0 = l->__tmp13;
          c->printf_locals.stp_sprintf_1.arg1 = l->__tmp14;
          c->printf_locals.stp_sprintf_1.arg2 = l->__tmp15;
          c->printf_locals.stp_sprintf_1.__retvalue = l->__tmp16;
          stp_sprintf_1 (c);
        #else // STP_LEGACY_PRINT
          _stp_snprintf (l->__tmp16, MAXSTRINGLEN, "[%lluns]p:%lld:%lld", l->__tmp13, l->__tmp14, l->__tmp15);
        #endif // STP_LEGACY_PRINT
        if (unlikely(c->last_error)) goto out;
        l->__tmp16;
      }), MAXSTRINGLEN);
      strlcpy (l->l_sample, l->__tmp11, MAXSTRINGLEN);
      l->__tmp11;
    });
    
    (void) 
    ({
      l->__tmp17 = (((int64_t) ( /* pure */ /* unprivileged */ MAXBACKTRACE )));
      l->l_remaining = l->__tmp17;
      l->__tmp17;
    });
    
    c->actionremaining -= 4;
    if (unlikely (c->actionremaining <= 0)) {
      c->last_error = "MAXACTION exceeded";
      c->last_stmt = "keyword at taptrek_run_ZIX2.stp:37:2";
      goto out;
    }
    if ((! (
      ({
        function_user_mode (c);
        if (unlikely(c->last_error)) goto out;
        c->locals[c->nesting+1].function_user_mode.__retvalue;
      })))) {
      {
        (void) 
        ({
          l->l_depth = ((int64_t)0LL);
          ((int64_t)0LL);
        });
        c->actionremaining -= 2;
        if (unlikely (c->actionremaining <= 0)) {
          c->last_error = "MAXACTION exceeded";
          c->last_stmt = "keyword at taptrek_run_ZIX2.stp:39:3";
          goto out;
        }
      top_0:
        if (! ((((l->l_depth) < ((((int64_t) ( /* pure */ /* unprivileged */ MAXBACKTRACE )))))))) goto break_0;
        {
          (void) 
          ({
            l->__tmp22 = 
            ({
              l->__tmp24 = l->l_depth;
              c->locals[c->nesting+1].function___stack_raw.l_n = l->__tmp24;
              function___stack_raw (c);
              if (unlikely(c->last_error)) goto out;
              c->actionremaining -= 1;
              if (unlikely (c->actionremaining <= 0)) {
                c->last_error = "MAXACTION exceeded";
                c->last_stmt = "identifier '__stack_raw' at taptrek_run_ZIX2.stp:41:11";
                goto out;
              }
              c->locals[c->nesting+1].function___stack_raw.__retvalue;
            });
            l->l_addr = l->__tmp22;
            l->__tmp22;
          });
          
          c->actionremaining -= 2;
          if (unlikely (c->actionremaining <= 0)) {
            c->last_error = "MAXACTION exceeded";
            c->last_stmt = "keyword at taptrek_run_ZIX2.stp:42:4";
            goto out;
          }
          if ((((l->l_addr) == (((int64_t)0LL))))) {
            c->actionremaining -= 1;
            if (unlikely (c->actionremaining <= 0)) {
              c->last_error = "MAXACTION exceeded";
              c->last_stmt = "keyword at taptrek_run_ZIX2.stp:42:19";
              goto out;
            }
            goto break_0;
          }
          
          {
            __label__ normal_fallthrough;
              {
              __label__ out;
              (void) 
              ({
                ({
                  l->__tmp28 = l->l_addr;
                  c->locals[c->nesting+1].function_modname.l_addr = l->__tmp28;
                  c->locals[c->nesting+1].function_modname.__retvalue = &l->__tmp26[0];
                  function_modname (c);
                  if (unlikely(c->last_error)) goto out;
                });
                strlcpy (l->l_name, l->__tmp26, MAXSTRINGLEN);
                l->__tmp26;
              });
              c->actionremaining -= 1;
              if (unlikely (c->actionremaining <= 0)) {
                c->last_error = "MAXACTION exceeded";
                c->last_stmt = "identifier 'name' at taptrek_run_ZIX2.stp:43:10";
                goto out;
              }
              goto normal_fallthrough;
              if (0) goto out;
              out:
              ;
            }
            if (likely(c->last_error == NULL)) goto out;
            c->last_error = NULL;
            c->actionremaining -= 1;
            if (unlikely (c->actionremaining <= 0)) {
              c->last_error = "MAXACTION exceeded";
              c->last_stmt = "keyword at taptrek_run_ZIX2.stp:43:4";
              goto out;
            }
            (void) 
            ({
              strlcpy (l->l_name, "vmlinux", MAXSTRINGLEN);
              "vmlinux";
            });
            c->actionremaining -= 1;
            if (unlikely (c->actionremaining <= 0)) {
              c->last_error = "MAXACTION exceeded";
              c->last_stmt = "identifier 'name' at taptrek_run_ZIX2.stp:43:42";
              goto out;
            }
            normal_fallthrough:
            ;
          }
          
          (void) 
          ({
            strlcpy (l->__tmp32, 
            ({
              l->__tmp34 = l->l_addr;
              strlcpy (l->__tmp35, l->l_name, MAXSTRINGLEN);
              #ifndef STP_LEGACY_PRINT
                c->printf_locals.stp_sprintf_2.arg0 = l->__tmp34;
                c->printf_locals.stp_sprintf_2.arg1 = l->__tmp35;
                c->printf_locals.stp_sprintf_2.__retvalue = l->__tmp36;
                stp_sprintf_2 (c);
              #else // STP_LEGACY_PRINT
                _stp_snprintf (l->__tmp36, MAXSTRINGLEN, ":%#p:%s", l->__tmp34, l->__tmp35);
              #endif // STP_LEGACY_PRINT
              if (unlikely(c->last_error)) goto out;
              l->__tmp36;
            }), MAXSTRINGLEN);
            strlcat (l->l_sample, l->__tmp32, MAXSTRINGLEN);
            l->l_sample;
          });
          
        }
        c->actionremaining -= 1;
        if (unlikely (c->actionremaining <= 0)) {
          c->last_error = "MAXACTION exceeded";
          c->last_stmt = "operator '{' at taptrek_run_ZIX2.stp:40:3";
          goto out;
        }
      continue_0:
        (void) 
        ({
          l->__tmp38 = l->l_depth;
          l->l_depth += 1;
          l->__tmp38;
        });
        goto top_0;
      break_0:
        ; /* dummy statement */
        
        (void) 
        ({
          l->__tmp39 = l->l_depth;
          l->l_remaining -= l->__tmp39;
          l->l_remaining;
        });
        
      }
      c->actionremaining -= 2;
      if (unlikely (c->actionremaining <= 0)) {
        c->last_error = "MAXACTION exceeded";
        c->last_stmt = "operator '{' at taptrek_run_ZIX2.stp:38:2";
        goto out;
      }
    }
    
    c->actionremaining -= 1;
    if (unlikely (c->actionremaining <= 0)) {
      c->last_error = "MAXACTION exceeded";
      c->last_stmt = "keyword at taptrek_run_ZIX2.stp:48:9";
      goto out;
    }
    if (l->l_uaddr) {
      (void) 
      ({
        l->l_depth = ((int64_t)0LL);
        ((int64_t)0LL);
      });
      c->actionremaining -= 2;
      if (unlikely (c->actionremaining <= 0)) {
        c->last_error = "MAXACTION exceeded";
        c->last_stmt = "keyword at taptrek_run_ZIX2.stp:50:3";
        goto out;
      }
    top_1:
      if (! ((((l->l_depth) < (l->l_remaining))))) goto break_1;
      {
        (void) 
        ({
          l->__tmp43 = 
          ({
            l->__tmp45 = l->l_depth;
            c->locals[c->nesting+1].function___ustack_raw.l_n = l->__tmp45;
            function___ustack_raw (c);
            if (unlikely(c->last_error)) goto out;
            c->actionremaining -= 1;
            if (unlikely (c->actionremaining <= 0)) {
              c->last_error = "MAXACTION exceeded";
              c->last_stmt = "identifier '__ustack_raw' at taptrek_run_ZIX2.stp:52:12";
              goto out;
            }
            c->locals[c->nesting+1].function___ustack_raw.__retvalue;
          });
          l->l_uaddr = l->__tmp43;
          l->__tmp43;
        });
        
        c->actionremaining -= 2;
        if (unlikely (c->actionremaining <= 0)) {
          c->last_error = "MAXACTION exceeded";
          c->last_stmt = "keyword at taptrek_run_ZIX2.stp:53:4";
          goto out;
        }
        if ((((l->l_uaddr) == (((int64_t)0LL))))) {
          c->actionremaining -= 1;
          if (unlikely (c->actionremaining <= 0)) {
            c->last_error = "MAXACTION exceeded";
            c->last_stmt = "keyword at taptrek_run_ZIX2.stp:53:20";
            goto out;
          }
          goto break_1;
        }
        
        (void) 
        ({
          l->__tmp47 = 
          ({
            l->__tmp49 = l->l_uaddr;
            c->locals[c->nesting+1].function_find_base.l_addr = l->__tmp49;
            function_find_base (c);
            if (unlikely(c->last_error)) goto out;
            c->locals[c->nesting+1].function_find_base.__retvalue;
          });
          l->l_base = l->__tmp47;
          l->__tmp47;
        });
        
        c->actionremaining -= 2;
        if (unlikely (c->actionremaining <= 0)) {
          c->last_error = "MAXACTION exceeded";
          c->last_stmt = "keyword at taptrek_run_ZIX2.stp:55:18";
          goto out;
        }
        if (l->l_base) {
          {
            (void) 
            ({
              ({
                l->__tmp53 = l->l_uaddr;
                c->locals[c->nesting+1].function_find_file.l_addr = l->__tmp53;
                c->locals[c->nesting+1].function_find_file.__retvalue = &l->__tmp51[0];
                function_find_file (c);
                if (unlikely(c->last_error)) goto out;
              });
              strlcpy (l->l_file, l->__tmp51, MAXSTRINGLEN);
              l->__tmp51;
            });
            
            (void) 
            ({
              strlcpy (l->__tmp55, 
              ({
                l->__tmp57 = l->l_base;
                strlcpy (l->__tmp58, l->l_file, MAXSTRINGLEN);
                #ifndef STP_LEGACY_PRINT
                  c->printf_locals.stp_sprintf_2.arg0 = l->__tmp57;
                  c->printf_locals.stp_sprintf_2.arg1 = l->__tmp58;
                  c->printf_locals.stp_sprintf_2.__retvalue = l->__tmp59;
                  stp_sprintf_2 (c);
                #else // STP_LEGACY_PRINT
                  _stp_snprintf (l->__tmp59, MAXSTRINGLEN, ":%#p:%s", l->__tmp57, l->__tmp58);
                #endif // STP_LEGACY_PRINT
                if (unlikely(c->last_error)) goto out;
                l->__tmp59;
              }), MAXSTRINGLEN);
              strlcat (l->l_sample, l->__tmp55, MAXSTRINGLEN);
              l->l_sample;
            });
            
          }
          c->actionremaining -= 2;
          if (unlikely (c->actionremaining <= 0)) {
            c->last_error = "MAXACTION exceeded";
            c->last_stmt = "operator '{' at taptrek_run_ZIX2.stp:56:18";
            goto out;
          }
        }
        
      }
    continue_1:
      (void) 
      ({
        l->__tmp61 = l->l_depth;
        l->l_depth += 1;
        l->__tmp61;
      });
      goto top_1;
    break_1:
      ; /* dummy statement */
      c->actionremaining -= 1;
      if (unlikely (c->actionremaining <= 0)) {
        c->last_error = "MAXACTION exceeded";
        c->last_stmt = "keyword at taptrek_run_ZIX2.stp:50:3";
        goto out;
      }
    }
    
    (void) 
    ({
      strlcpy (l->__tmp62, l->l_sample, MAXSTRINGLEN);
      #ifndef STP_LEGACY_PRINT
        c->printf_locals.stp_printf_3.arg0 = l->__tmp62;
        stp_printf_3 (c);
      #else // STP_LEGACY_PRINT
        _stp_printf ("%s\n", l->__tmp62);
      #endif // STP_LEGACY_PRINT
      if (unlikely(c->last_error)) goto out;
      ((int64_t)0LL);
    });
    
  }
  c->actionremaining -= 1;
  if (unlikely (c->actionremaining <= 0)) {
    c->last_error = "MAXACTION exceeded";
    c->last_stmt = "operator '{' at /opt/tooling/adit/systemtap/share/systemtap/tapset/linux/perf.stp:20:60";
    goto out;
  }
out:
  stp_unlock_probe(locks, ARRAY_SIZE(locks));
  _stp_print_flush();
}

static struct stap_probe stap_probes[] = {
  STAP_PROBE_INIT(0, &probe_2653, "perf.type(1).config(0).sample(1000000)", "perf.sw.cpu_clock.sample(1000000)", "taptrek_run_ZIX2.stp:28:7", " from: perf.type(1).config(0).sample(1000000) from: perf.sw.cpu_clock.sample(1000000) from: perf.sw.cpu_clock.sample(1000000)"),
};

/* ---- perf probes ---- */
#include <linux/perf_event.h>
#include "linux/perf.h"

static void handle_perf_probe (unsigned i, struct pt_regs *regs);
#ifdef STAPCONF_PERF_HANDLER_NMI
static void enter_perf_probe_0 (struct perf_event *e, int nmi, struct perf_sample_data *data, struct pt_regs *regs);
#else
static void enter_perf_probe_0 (struct perf_event *e, struct perf_sample_data *data, struct pt_regs *regs);
#endif

static struct stap_perf_probe stap_perf_probes [1] = {
  {
    .attr={ .type=1ULL, .config=0ULL, { .sample_period=1000000ULL }},
    .callback=enter_perf_probe_0, 
    .probe=(&stap_probes[0]), 
    .system_wide=1, 
  },
};

#ifdef STAPCONF_PERF_HANDLER_NMI
static void enter_perf_probe_0 (struct perf_event *e, int nmi, struct perf_sample_data *data, struct pt_regs *regs)
#else
static void enter_perf_probe_0 (struct perf_event *e, struct perf_sample_data *data, struct pt_regs *regs)
#endif
{
  handle_perf_probe(0, regs);
}

static void handle_perf_probe (unsigned i, struct pt_regs *regs)
{
  struct stap_perf_probe* stp = & stap_perf_probes [i];
  #ifdef STP_ALIBI
  atomic_inc(probe_alibi(stp->probe->index));
  #else
  struct context* __restrict__ c = NULL;
  #if !INTERRUPTIBLE
  unsigned long flags;
  #endif
  #ifdef STP_TIMING
  Stat stat = probe_timing(stp->probe->index);
  #endif
  #if defined(STP_TIMING) || defined(STP_OVERLOAD)
  cycles_t cycles_atstart = get_cycles ();
  #endif
  #if !INTERRUPTIBLE
  local_irq_save (flags);
  #endif
  if (unlikely ((((unsigned long) (& c)) & (THREAD_SIZE-1))
    < (MINSTACKSPACE + sizeof (struct thread_info)))) {
    atomic_inc (skipped_count());
    #ifdef STP_TIMING
    atomic_inc (skipped_count_lowstack());
    #endif
    goto probe_epilogue;
  }
  if (atomic_read (session_state()) != STAP_SESSION_RUNNING)
    goto probe_epilogue;
  c = _stp_runtime_entryfn_get_context();
  if (!c) {
    #if !INTERRUPTIBLE
    atomic_inc (skipped_count());
    #endif
    #ifdef STP_TIMING
    atomic_inc (skipped_count_reentrant());
    #endif
    goto probe_epilogue;
  }
  
  c->last_stmt = 0;
  c->last_error = 0;
  c->nesting = -1;
  c->uregs = 0;
  c->kregs = 0;
  #if defined __ia64__
  c->unwaddr = 0;
  #endif
  c->probe_point = stp->probe->pp;
  #ifdef STP_NEED_PROBE_NAME
  c->probe_name = stp->probe->pn;
  #endif
  c->probe_type = stp_probe_type_perf;
  memset(&c->ips, 0, sizeof(c->ips));
  c->user_mode_p = 0; c->full_uregs_p = 0;
  #ifdef STAP_NEED_REGPARM
  c->regparm = 0;
  #endif
  #if INTERRUPTIBLE
  c->actionremaining = MAXACTION_INTERRUPTIBLE;
  #else
  c->actionremaining = MAXACTION;
  #endif
  #if defined(STP_NEED_UNWIND_DATA)
  c->uwcache_user.state = uwcache_uninitialized;
  c->uwcache_kernel.state = uwcache_uninitialized;
  #endif
  if (user_mode(regs)) {
    c->user_mode_p = 1;
    c->uregs = regs;
  } else {
    c->kregs = regs;
  }
  (*stp->probe->ph) (c);
  #if defined(STP_TIMING) || defined(STP_OVERLOAD)
  {
    cycles_t cycles_atend = get_cycles ();
    int32_t cycles_elapsed = ((int32_t)cycles_atend > (int32_t)cycles_atstart)
      ? ((int32_t)cycles_atend - (int32_t)cycles_atstart)
      : (~(int32_t)0) - (int32_t)cycles_atstart + (int32_t)cycles_atend + 1;
    #ifdef STP_TIMING
    if (likely (stat)) _stp_stat_add(stat, cycles_elapsed);
    #endif
    #ifdef STP_OVERLOAD
    {
      cycles_t interval = (cycles_atend > c->cycles_base)
        ? (cycles_atend - c->cycles_base)
        : (STP_OVERLOAD_INTERVAL + 1);
      c->cycles_sum += cycles_elapsed;
      if (interval > STP_OVERLOAD_INTERVAL) {
        if (c->cycles_sum > STP_OVERLOAD_THRESHOLD) {
          _stp_error ("probe overhead exceeded threshold");
          atomic_set (session_state(), STAP_SESSION_ERROR);
          atomic_inc (error_count());
        }
        c->cycles_base = cycles_atend;
        c->cycles_sum = 0;
      }
    }
    #endif
  }
  #endif
  c->probe_point = 0;
  #ifdef STP_NEED_PROBE_NAME
  c->probe_name = 0;
  #endif
  c->probe_type = 0;
  if (unlikely (c->last_error && c->last_error[0])) {
    if (c->last_stmt != NULL)
      _stp_softerror ("%s near %s", c->last_error, c->last_stmt);
    else
      _stp_softerror ("%s", c->last_error);
    atomic_inc (error_count());
    if (atomic_read (error_count()) > MAXERRORS) {
      atomic_set (session_state(), STAP_SESSION_ERROR);
      _stp_exit ();
    }
  }
probe_epilogue:
  if (unlikely (atomic_read (skipped_count()) > MAXSKIPPED)) {
    if (unlikely (pseudo_atomic_cmpxchg(session_state(), STAP_SESSION_RUNNING, STAP_SESSION_ERROR) == STAP_SESSION_RUNNING))
    _stp_error ("Skipped too many probes, check MAXSKIPPED or try again with stap -t for more details.");
  }
  _stp_runtime_entryfn_put_context(c);
  #if !INTERRUPTIBLE
  local_irq_restore (flags);
  #endif
  #endif // STP_ALIBI
}

#include "linux/perf.c"

#ifdef STAP_NEED_TRACEPOINTS
#include "linux/stp_tracepoint.c"
#endif

static int systemtap_module_init (void) {
  int rc = 0;
  int cpu;
  int i=0, j=0;
  const char *probe_point = "";
  {
    const char* release = UTS_RELEASE;
    #ifdef STAPCONF_GENERATED_COMPILE
    const char* version = UTS_VERSION;
    #endif
    if (strcmp (release, "3.14.47-03390-g8f5eb3c-dirty")) {
      _stp_error ("module release mismatch (%s vs %s)", release, "3.14.47-03390-g8f5eb3c-dirty");
      rc = -EINVAL;
    }
    #ifdef STAPCONF_GENERATED_COMPILE
    if (strcmp (utsname()->version, version)) {
      _stp_error ("module version mismatch (%s vs %s), release %s", version, utsname()->version, release);
      rc = -EINVAL;
    }
    #endif
    if (_stp_module_check()) rc = -EINVAL;
    if (_stp_privilege_credentials == 0) {
      if (STP_PRIVILEGE_CONTAINS(STP_PRIVILEGE, STP_PR_STAPDEV) ||
          STP_PRIVILEGE_CONTAINS(STP_PRIVILEGE, STP_PR_STAPUSR)) {
        _stp_privilege_credentials = STP_PRIVILEGE;
        #ifdef DEBUG_PRIVILEGE
          _dbug("User's privilege credentials default to %s\n",
                privilege_to_text(_stp_privilege_credentials));
        #endif
      }
      else {
        _stp_error ("Unable to verify that you have the required privilege credentials to run this module (%s required). You must use staprun version 1.7 or higher.",
                    privilege_to_text(STP_PRIVILEGE));
        rc = -EINVAL;
      }
    }
    else {
      #ifdef DEBUG_PRIVILEGE
        _dbug("User's privilege credentials provided as %s\n",
              privilege_to_text(_stp_privilege_credentials));
      #endif
      if (! STP_PRIVILEGE_CONTAINS(_stp_privilege_credentials, STP_PRIVILEGE)) {
        _stp_error ("Your privilege credentials (%s) are insufficient to run this module (%s required).",
                    privilege_to_text(_stp_privilege_credentials), privilege_to_text(STP_PRIVILEGE));
        rc = -EINVAL;
      }
    }
  }
  if (rc) goto out;
  rc = stp_session_init();
  if (rc) {
    _stp_error ("couldn't initialize the main session (rc %d)", rc);
    goto out;
  }
  #ifdef STAP_NEED_GETTIMEOFDAY
  rc = _stp_init_time();
  if (rc) {
    _stp_error ("couldn't initialize gettimeofday");
    goto out;
  }
  #endif
  #ifdef STAP_NEED_TRACEPOINTS
  rc = stp_tracepoint_init();
  if (rc) {
    _stp_error ("couldn't initialize tracepoints");
    goto out;
  }
  #endif
  (void) probe_point;
  (void) i;
  (void) j;
  atomic_set (session_state(), STAP_SESSION_STARTING);
  rc = _stp_runtime_contexts_alloc();
  if (rc != 0)
    goto out;
  _stp_print_kernel_info("2.8/0.161", (num_online_cpus() * sizeof(struct context)), 1);
  #if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,20)
  INIT_WORK(&module_refresher_work, module_refresher, NULL);
  #else
  INIT_WORK(&module_refresher_work, module_refresher);
  #endif
  rc = _stp_perf_init_n (stap_perf_probes, 1, &probe_point);
  if (rc) {
    if (probe_point)
      _stp_error ("probe %s registration error (rc %d)", probe_point, rc);
    atomic_set (session_state(), STAP_SESSION_ERROR);
    goto out;
  }
  if (atomic_read (session_state()) == STAP_SESSION_STARTING)
    atomic_set (session_state(), STAP_SESSION_RUNNING);
  
  #ifdef STP_ON_THE_FLY_TIMER_ENABLE
  hrtimer_init(&module_refresh_timer, CLOCK_MONOTONIC,
               HRTIMER_MODE_REL);
  module_refresh_timer.function = &module_refresh_timer_cb;
  #endif /* STP_ON_THE_FLY_TIMER_ENABLE */
  return 0;
out:
  atomic_set (session_state(), STAP_SESSION_STOPPED);
  stp_synchronize_sched();
  #ifdef STAP_NEED_TRACEPOINTS
   stp_tracepoint_exit();
  #endif
  #ifdef STAP_NEED_GETTIMEOFDAY
   _stp_kill_time();
  #endif
  _stp_runtime_contexts_free();
  return rc;
}


static void systemtap_module_refresh (const char *modname) {
  int state;
  int i=0, j=0;
  #if defined(STP_TIMING)
  cycles_t cycles_atstart = get_cycles();
  #endif
  mutex_lock(&module_refresh_mutex);
  state = atomic_read (session_state());
  if (state != STAP_SESSION_RUNNING && state != STAP_SESSION_STARTING && state != STAP_SESSION_ERROR) {
    #if defined(__KERNEL__)
    if (state != STAP_SESSION_STOPPING)
      printk (KERN_ERR "stap module notifier triggered in unexpected state %d\n", state);
    #endif
    mutex_unlock(&module_refresh_mutex);
    return;
  }
  (void) i;
  (void) j;
  #if defined(STP_TIMING)
  if (likely(g_refresh_timing)) {
    cycles_t cycles_atend = get_cycles ();
    int32_t cycles_elapsed = ((int32_t)cycles_atend > (int32_t)cycles_atstart)
      ? ((int32_t)cycles_atend - (int32_t)cycles_atstart)
      : (~(int32_t)0) - (int32_t)cycles_atstart + (int32_t)cycles_atend + 1;
    _stp_stat_add(g_refresh_timing, cycles_elapsed);
  }
  #endif
  mutex_unlock(&module_refresh_mutex);
}


static void systemtap_module_exit (void) {
  int i=0, j=0;
  (void) i;
  (void) j;
  if (atomic_read (session_state()) == STAP_SESSION_STARTING)
    return;
  if (atomic_read (session_state()) == STAP_SESSION_RUNNING)
    atomic_set (session_state(), STAP_SESSION_STOPPING);
  #ifdef STP_ON_THE_FLY_TIMER_ENABLE
  hrtimer_cancel(&module_refresh_timer);
  #endif
  stp_synchronize_sched();
  mutex_lock(&module_refresh_mutex);
  _stp_perf_del_n (stap_perf_probes, 1);
  mutex_unlock(&module_refresh_mutex);
  stp_synchronize_sched();
  _stp_runtime_context_wait();
  atomic_set (session_state(), STAP_SESSION_STOPPED);
  stp_synchronize_sched();
  _stp_runtime_contexts_free();
  #ifdef STAP_NEED_TRACEPOINTS
   stp_tracepoint_exit();
  #endif
  #ifdef STAP_NEED_GETTIMEOFDAY
   _stp_kill_time();
  #endif
  preempt_disable();
  #if defined(STP_TIMING) || defined(STP_ALIBI)
  _stp_printf("----- probe hit report: \n");
  for (i = 0; i < ARRAY_SIZE(stap_probes); ++i) {
    const struct stap_probe *const p = &stap_probes[i];
    #ifdef STP_ALIBI
    int alibi = atomic_read(probe_alibi(i));
    if (alibi)
      _stp_printf ("%s, (%s), hits: %d,%s, index: %d\n",
          p->pp, p->location, alibi, p->derivation, i);
    #endif
    #ifdef STP_TIMING
    if (likely (probe_timing(i))) {
      struct stat_data *stats = _stp_stat_get (probe_timing(i), 0);
      if (stats->count) {
        int64_t avg = _stp_div64 (NULL, stats->sum, stats->count);
        _stp_printf ("%s, (%s), hits: %lld, cycles: %lldmin/%lldavg/%lldmax,%s, index: %d\n",
            p->pp, p->location, (long long) stats->count,
            (long long) stats->min, (long long) avg, (long long) stats->max,
            p->derivation, i);
      }
      _stp_stat_del (probe_timing(i));
    }
    #endif
  }
  #if defined(STP_TIMING)
  _stp_printf("----- refresh report:\n");
  if (likely (g_refresh_timing)) {
    struct stat_data *stats = _stp_stat_get (g_refresh_timing, 0);
    if (stats->count) {
      int64_t avg = _stp_div64 (NULL, stats->sum, stats->count);
      _stp_printf ("hits: %lld, cycles: %lldmin/%lldavg/%lldmax\n",
          (long long) stats->count, (long long) stats->min, 
          (long long) avg, (long long) stats->max);
    }
    _stp_stat_del (g_refresh_timing);
  }
  #endif
  _stp_print_flush();
  #endif
  if (atomic_read (skipped_count()) || atomic_read (error_count()) || atomic_read (skipped_count_reentrant())) {
    _stp_warn ("Number of errors: %d, skipped probes: %d\n", (int) atomic_read (error_count()), (int) atomic_read (skipped_count()));
    #ifdef STP_TIMING
    {
      int ctr;
      ctr = atomic_read (skipped_count_lowstack());
      if (ctr) _stp_warn ("Skipped due to low stack: %d\n", ctr);
      ctr = atomic_read (skipped_count_reentrant());
      if (ctr) _stp_warn ("Skipped due to reentrancy: %d\n", ctr);
      ctr = atomic_read (skipped_count_uprobe_reg());
      if (ctr) _stp_warn ("Skipped due to uprobe register failure: %d\n", ctr);
      ctr = atomic_read (skipped_count_uprobe_unreg());
      if (ctr) _stp_warn ("Skipped due to uprobe unregister failure: %d\n", ctr);
    }
    #endif
    _stp_print_flush();
  }
  preempt_enable_no_resched();
}


static int systemtap_kernel_module_init (void) {
  int rc = 0;
  int i=0, j=0;
  if (rc) {
    goto out;
  }
out:
  return rc;
}


static void systemtap_kernel_module_exit (void) {
  int i=0, j=0;
}


#include "stap-symbols.h"
MODULE_DESCRIPTION("systemtap-generated probe");
MODULE_LICENSE("GPL");
